﻿Public Class Form1

    ' Store conversion history
    Private ConversionHistory As New List(Of String)

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' Set default radio button
        rbCelsius.Checked = True
        ' Set multiline textbox properties
        txtHistory.ReadOnly = True
        txtHistory.ScrollBars = ScrollBars.Vertical
    End Sub

    Private Sub btnAbsoluteZero_Click(sender As Object, e As EventArgs)
        MessageBox.Show("Absolute Zero is the lowest possible temperature:" & vbCrLf &
                        " Celsius: -273.15°C" & vbCrLf &
                        " Fahrenheit: -459.67°F" & vbCrLf &
                        " Kelvin: 0 K", "Absolute Zero")
    End Sub

    Private Function GetDoubleFromTextBox(tb As TextBox) As Double?
        Dim val As Double
        If Double.TryParse(tb.Text, val) Then
            Return val
        Else
            MessageBox.Show("Please enter a valid number in " & tb.Name)
            Return Nothing
        End If
    End Function

    Private Sub btnCtoKf_Click(sender As Object, e As EventArgs)
        Dim c As Double? = GetDoubleFromTextBox(txtCelsius)
        If c Is Nothing Then Return
        If c < -273.15 Then
            MessageBox.Show("Temperature below absolute zero.")
            Return
        End If
        Dim k As Double = c + 273.15
        Dim f As Double = (c * 9 / 5) + 32
        lblResult.Text = $"C: {c:F2}°C, K: {k:F2}K, F: {f:F2}°F"
        ConversionHistory.Add($"C to K/F: C: {c:F2}°C -> K: {k:F2}K, F: {f:F2}°F")
        UpdateHistory()
    End Sub

    Private Sub btnKtoCf_Click(sender As Object, e As EventArgs)
        Dim k As Double? = GetDoubleFromTextBox(txtKelvin)
        If k Is Nothing Then Return
        If k < 0 Then
            MessageBox.Show("Kelvin cannot be negative.")
            Return
        End If
        Dim c As Double = k - 273.15
        Dim f As Double = (c * 9 / 5) + 32
        lblResult.Text = $"K: {k:F2}K, C: {c:F2}°C, F: {f:F2}°F"
        ConversionHistory.Add($"K to C/F: K: {k:F2}K -> C: {c:F2}°C, F: {f:F2}°F")
        UpdateHistory()
    End Sub

    Private Sub btnFtoCk_Click(sender As Object, e As EventArgs)
        Dim f As Double? = GetDoubleFromTextBox(txtFahrenheit)
        If f Is Nothing Then Return
        Dim c As Double = (f - 32) * 5 / 9
        If c < -273.15 Then
            MessageBox.Show("Result below absolute zero!")
            Return
        End If
        Dim k As Double = c + 273.15
        lblResult.Text = $"F: {f:F2}°F, C: {c:F2}°C, K: {k:F2}K"
        ConversionHistory.Add($"F to C/K: F: {f:F2}°F -> C: {c:F2}°C, K: {k:F2}K")
        UpdateHistory()
    End Sub

    Private Sub btnCtoF_Click(sender As Object, e As EventArgs)
        Dim c As Double? = GetDoubleFromTextBox(txtCelsius)
        If c Is Nothing Then Return
        If c < -273.15 Then
            MessageBox.Show("Temperature below absolute zero.")
            Return
        End If
        Dim f As Double = (c * 9 / 5) + 32
        lblResult.Text = $"C: {c:F2}°C, F: {f:F2}°F"
        ConversionHistory.Add($"C to F: C: {c:F2}°C -> F: {f:F2}°F")
        UpdateHistory()
    End Sub

    Private Sub btnFtoC_Click(sender As Object, e As EventArgs)
        Dim f As Double? = GetDoubleFromTextBox(txtFahrenheit)
        If f Is Nothing Then Return
        Dim c As Double = (f - 32) * 5 / 9
        If c < -273.15 Then
            MessageBox.Show("Result below absolute zero!")
            Return
        End If
        lblResult.Text = $"F: {f:F2}°F, C: {c:F2}°C"
        ConversionHistory.Add($"F to C: F: {f:F2}°F -> C: {c:F2}°C")
        UpdateHistory()
    End Sub

    Private Sub btnConvertAny_Click(sender As Object, e As EventArgs)
        Dim choice As String = ""
        If rbCelsius.Checked Then choice = "C"
        If rbFahrenheit.Checked Then choice = "F"
        If rbKelvin.Checked Then choice = "K"

        Select Case choice
            Case "C"
                Dim c As Double? = GetDoubleFromTextBox(txtCelsius)
                If c Is Nothing Then Return
                If c < -273.15 Then
                    MessageBox.Show("Below absolute zero.")
                    Return
                End If
                Dim f As Double = (c * 9 / 5) + 32
                Dim k As Double = c + 273.15
                lblResult.Text = $"C: {c:F2}°C, F: {f:F2}°F, K: {k:F2}K"
                ConversionHistory.Add($"Any Input (C): C: {c:F2}°C -> F: {f:F2}°F, K: {k:F2}K")
            Case "F"
                Dim f As Double? = GetDoubleFromTextBox(txtFahrenheit)
                If f Is Nothing Then Return
                Dim c As Double = (f - 32) * 5 / 9
                If c < -273.15 Then
                    MessageBox.Show("Below absolute zero.")
                    Return
                End If
                Dim k As Double = c + 273.15
                lblResult.Text = $"F: {f:F2}°F, C: {c:F2}°C, K: {k:F2}K"
                ConversionHistory.Add($"Any Input (F): F: {f:F2}°F -> C: {c:F2}°C, K: {k:F2}K")
            Case "K"
                Dim k As Double? = GetDoubleFromTextBox(txtKelvin)
                If k Is Nothing Then Return
                If k < 0 Then
                    MessageBox.Show("Kelvin cannot be negative.")
                    Return
                End If
                Dim c As Double = k - 273.15
                Dim f As Double = (c * 9 / 5) + 32
                lblResult.Text = $"K: {k:F2}K, C: {c:F2}°C, F: {f:F2}°F"
                ConversionHistory.Add($"Any Input (K): K: {k:F2}K -> C: {c:F2}°C, F: {f:F2}°F")
            Case Else
                MessageBox.Show("Please select a conversion scale.")
        End Select
        UpdateHistory()
    End Sub

    Private Sub btnShowHistory_Click(sender As Object, e As EventArgs)
        txtHistory.Clear()
        If ConversionHistory.Count = 0 Then
            txtHistory.Text = "No conversions yet."
        Else
            For Each line As String In ConversionHistory
                txtHistory.AppendText(line & vbCrLf)
            Next
        End If
    End Sub

    Private Sub UpdateHistory()
        ' Optional: update UI if needed
    End Sub

End Class
